<template>
  <el-dialog :title="title" :visible.sync="dialogFormVisible" width="500px" @close="close">
    <el-form ref="form" label-width="80px" :model="form" :rules="rules">
      <el-form-item label="用户名" prop="username">
        <el-input v-model.trim="form.username" autocomplete="off" />
      </el-form-item>
      <el-form-item label="密码" prop="password">
        <el-input v-model.trim="form.password" autocomplete="off" type="password" />
      </el-form-item>
      <el-form-item label="昵称" prop="nickname">
        <el-input v-model.trim="form.nickname" autocomplete="off" />
      </el-form-item>
      <el-form-item label="权限" prop="permissions">
        <el-select v-model="form.permissions" multiple placeholder="请选择权限">
          <el-option v-for="item in permissionList" :key="item.id" :label="item.name" :value="item.id" />
        </el-select>
      </el-form-item>
      <el-form-item label="应用" prop="appId">
        <el-select v-model="form.appId" placeholder="请选择应用">
          <el-option v-for="item in applicationList" :key="item.id" :label="item.name" :value="item.id" />
        </el-select>
      </el-form-item>
      <el-form-item label="头像" prop="avatar">
        <single-upload
          style="width: 100px; height: 100px"
          upload-url="http://127.0.0.1:3999/management/api/common/upload"
          @upload-success="handleUploadSuccess"
        />
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="close">取 消</el-button>
      <el-button type="primary" @click="save">确 定</el-button>
    </div>
  </el-dialog>
</template>

<script>
  import { doEdit } from '@/api/userManagement'
  import { getList } from '@/api/roleManagement'
  import { getList as getApplicationList } from '@/api/appManagement'
  import SingleUpload from '@/components/SingleUpload'
  export default {
    name: 'UserManagementEdit',
    components: { SingleUpload },
    data() {
      return {
        form: {
          username: '',
          password: '',
          nickname: '',
          permissions: '',
          appId: '',
        },
        permissionList: [],
        applicationList: [],
        rules: {
          username: [{ required: true, trigger: 'blur', message: '请输入用户名' }],
          password: [{ required: true, trigger: 'blur', message: '请输入密码' }],
          permissions: [{ required: true, trigger: 'blur', message: '请选择权限' }],
          appId: [{ required: true, trigger: 'blur', message: '请选择应用' }],
        },
        title: '',
        dialogFormVisible: false,
        queryForm: {
          pageNo: 1,
          pageSize: 100,
        },
      }
    },
    created() {
      this.fetchRoleData()
      this.fetchApplicationData()
    },
    methods: {
      showEdit(row) {
        if (!row) {
          this.title = '添加'
        } else {
          this.title = '编辑'
          this.form = Object.assign({}, row)
        }
        this.dialogFormVisible = true
      },
      close() {
        this.$refs['form'].resetFields()
        this.form = this.$options.data().form
        this.dialogFormVisible = false
      },
      save() {
        this.$refs['form'].validate(async (valid) => {
          if (valid) {
            const { msg } = await doEdit(this.form)
            this.$baseMessage(msg, 'success')
            this.$emit('fetch-data')
            this.close()
          } else {
            return false
          }
        })
      },
      async fetchRoleData() {
        this.listLoading = true
        const { data } = await getList(this.queryForm)
        this.permissionList = data.list
      },
      async fetchApplicationData() {
        const { data } = await getApplicationList(this.queryForm)
        this.applicationList = data.list
      },
      handleUploadSuccess(url) {
        this.form.avatar = url
      },
    },
  }
</script>
